'this program uses the data lines, DB4 to DB7(pins 11 to 14) of a standard LCD as input pins
'while keeping all the normal display functions working.
'it allows the user access to 4 buttons that may normally mean migration to a larger PIC chip.
'this system may not work in all occasions, but seems to work very well in mine!

'program and hardware design by MARK RODGERS, 20/01/04. it may well have been done before
'but I have not seen it, monkeys and Shakespear!

'the method is very simple.
'during any routine the program is used (in a loop) it sets the data lines used by your LCD
'to inputs and checks them for a key press.

'The LCD keeps its characters on screen during the button test and does not get corrupted due
'to the display storing the characters on the LCD until they change!

'I am sure the idea can be used in many circuits and in many other ways!

'this program can only be used with lcd_key.bmp

'it can be used as a subroutine or as an include file


		dim key			  	   				   'variable to hold the key press
		dim length							   'length of delay in milliseconds
		length=1  		  	   				   'my system works with 1ms
		
button_check:
		
		key=0  			   	   				   'make key variable zero
		
		'make RC1(the common button connection)an output
		trisc.1=0
		
		'set the above pin low (connect to 0volts)during this routine
		low portc.1
		
		'set the data pin of LCD to an input and if the button is pressed(ie=0),give "key" a value
		'the short delay is needed to ensure a correct reading,it will not work without it.
		'the pin is then set to an output for use by the LCD
		trisd.4=1:delayms length:if portd.4=0 then key=1:trisd.4=0
		trisd.5=1:delayms length:if portd.5=0 then key=2:trisd.5=0
		trisd.6=1:delayms length:if portd.6=0 then key=3:trisd.6=0
		trisd.7=1:delayms length:if portd.7=0 then key=4:trisd.7=0
		
		'print at 1,1,"Key Pressed= ",dec key  'show the result on screen
		
		trisc.1=1		  		   		 	  'set the common connection to an input.
		
		return
